import { jsx as d, jsxs as x, Fragment as L } from "react/jsx-runtime";
import i from "clsx";
import * as m from "react";
import B, { useId as V, useRef as F, useEffect as G } from "react";
import { useFloating as D, useClick as W, useDismiss as X, useRole as Y, useInteractions as q, useMergeRefs as H, FloatingPortal as J, FloatingOverlay as K, FloatingFocusManager as Q } from "@floating-ui/react";
/*!
  @versini/ui-panel v1.2.4
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PANEL__ || (window.__VERSINI_UI_PANEL__ = {
    version: "1.2.4",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const C = "av-messagebox", P = "av-panel", $ = "av-button";
/*!
  @versini/ui-spacing v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Z = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
}, M = "icon", ee = "button", re = "link", te = ({
  type: e,
  size: t,
  labelRight: r,
  labelLeft: a,
  align: o
}) => {
  const n = "text-sm font-medium max-h-8 py-0", c = "text-base font-medium max-h-9 py-1", l = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case ee:
      return i("px-4", {
        [n]: t === "small",
        [c]: t === "medium",
        [l]: t === "large"
      });
    case re:
      return i("px-4 text-center", {
        [n]: t === "small",
        [c]: t === "medium",
        [l]: t === "large"
      });
    case M:
      return i("inline-flex items-center", {
        "justify-center": o === "center",
        "justify-start": o === "left",
        "justify-end": o === "right",
        "h-6 w-6 p-0": t === "small" && !(r || a),
        "h-6 px-4 text-sm font-medium": t === "small" && (r || a),
        "h-8 w-8 p-1": t === "medium" && !(r || a),
        "h-8 px-4 text-base font-medium": t === "medium" && (r || a),
        "h-12 w-12 p-2": t === "large" && !(r || a),
        "h-12 px-4 text-lg font-medium": t === "large" && (r || a)
      });
  }
}, ae = ({
  mode: e,
  noBackground: t,
  noTruncate: r,
  variant: a,
  radius: o
}) => {
  if (t)
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small"
    });
  if (a === "primary")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !r,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !r,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !r,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "selected")
    return i("not-prose", {
      "rounded-full": o === "large",
      "rounded-md": o === "medium",
      "rounded-sm": o === "small",
      truncate: !r,
      "bg-action-selected-dark text-copy-light": e === "dark",
      "bg-action-selected-light text-copy-lighter": e === "light",
      "bg-action-selected-dark text-copy-light dark:bg-action-selected-light dark:text-copy-lighter": e === "system",
      "bg-action-selected-light text-copy-lighter dark:bg-action-selected-dark dark:text-copy-light": e === "alt-system"
    });
}, oe = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (r === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (r === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
  if (r === "selected")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-selected-dark-hover": e === "dark",
      "hover:bg-action-selected-light-hover": e === "light",
      "hover:bg-action-selected-dark-hover dark:hover:bg-action-selected-light-hover": e === "system",
      "hover:bg-action-selected-light-hover dark:hover:bg-action-selected-dark-hover": e === "alt-system"
    });
}, ie = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (r === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (r === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
  if (r === "selected")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-selected-dark-active": e === "dark",
      "active:bg-action-selected-light-active": e === "light",
      "active:bg-action-selected-dark-active dark:active:bg-action-selected-light-active": e === "system",
      "active:bg-action-selected-light-active dark:active:bg-action-selected-dark-active": e === "alt-system"
    });
}, de = ({
  mode: e,
  noBorder: t,
  variant: r
}) => {
  if (t)
    return "border border-transparent";
  if (r === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (r === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (r === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
  if (r === "selected")
    return i("border", {
      "border-border-selected-dark": e === "dark",
      "border-border-selected-medium": e === "light",
      "border-border-selected-dark dark:border-border-selected-medium": e === "system",
      "border-border-selected-medium dark:border-border-selected-dark": e === "alt-system"
    });
}, ne = ({
  focusMode: e
}) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), O = ({
  type: e,
  className: t,
  raw: r,
  mode: a,
  focusMode: o,
  disabled: n,
  fullWidth: c,
  size: l,
  noBorder: h,
  labelRight: s,
  labelLeft: b,
  spacing: v,
  noBackground: u,
  variant: g,
  noTruncate: p,
  align: k,
  radius: f
}) => (g || (g = "primary"), r ? i($, t) : i(
  $,
  t,
  Z(v),
  ae({
    mode: a,
    variant: g,
    noBackground: u,
    noTruncate: p,
    radius: f
  }),
  te({ type: e, size: l, labelRight: s, labelLeft: b, align: k }),
  de({ mode: a, variant: g, noBorder: h }),
  ne({ focusMode: o }),
  oe({ mode: a, variant: g, disabled: n }),
  ie({ mode: a, variant: g, disabled: n }),
  {
    "w-full": c,
    "disabled:cursor-not-allowed disabled:opacity-50": n
  }
)), le = (e, t, r) => {
  var a;
  !t && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof r == "function" && r(e);
}, R = B.forwardRef((e, t) => {
  const { onClick: r, noInternalClick: a = !1, ...o } = e;
  return /* @__PURE__ */ d(
    "button",
    {
      ref: t,
      onClick: (n) => {
        le(n, a, r);
      },
      ...o
    }
  );
});
R.displayName = "BaseButton";
const A = B.forwardRef(
  ({
    children: e,
    disabled: t = !1,
    mode: r = "system",
    focusMode: a = "system",
    fullWidth: o = !1,
    className: n,
    type: c = "button",
    raw: l = !1,
    noBorder: h = !1,
    "aria-label": s,
    label: b,
    size: v = "medium",
    labelRight: u,
    labelLeft: g,
    spacing: p,
    noBackground: k = !1,
    align: f = "center",
    radius: I = "large",
    ...N
  }, E) => {
    const S = O({
      type: M,
      mode: r,
      focusMode: a,
      fullWidth: o,
      disabled: t,
      raw: l,
      className: n,
      noBorder: h,
      size: v,
      labelRight: u,
      labelLeft: g,
      spacing: p,
      noBackground: k,
      align: f,
      radius: I
    }), T = i({
      "text-copy-accent-dark": r === "light" && !l,
      "text-copy-light": r === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": r === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": r === "system" && !l
    });
    return /* @__PURE__ */ x(
      R,
      {
        ref: E,
        className: S,
        disabled: t,
        type: c,
        "aria-label": s || b,
        ...N,
        children: [
          g && /* @__PURE__ */ d("span", { className: "pr-2", children: g }),
          /* @__PURE__ */ d("div", { className: T, children: e }),
          u && /* @__PURE__ */ d("span", { className: "pl-2", children: u })
        ]
      }
    );
  }
);
A.displayName = "ButtonIcon";
/*!
  @versini/ui-button v1.7.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "1.7.0",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ce = B.forwardRef(
  ({
    children: e,
    disabled: t = !1,
    mode: r = "system",
    focusMode: a = "system",
    fullWidth: o = !1,
    className: n,
    type: c = "button",
    raw: l = !1,
    noBorder: h = !1,
    "aria-label": s,
    label: b,
    size: v = "medium",
    labelRight: u,
    labelLeft: g,
    spacing: p,
    noBackground: k = !1,
    align: f = "center",
    active: I = !1,
    radius: N = "large",
    ...E
  }, S) => {
    const T = O({
      type: M,
      mode: r,
      focusMode: a,
      fullWidth: o,
      disabled: t,
      raw: l,
      className: n,
      noBorder: h,
      size: v,
      labelRight: u,
      labelLeft: g,
      spacing: p,
      noBackground: k,
      align: f,
      radius: N
    }), z = i({
      "text-copy-accent-dark": r === "light" && !l,
      "text-copy-light": r === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": r === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": r === "system" && !l
    }), j = I ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": r === "dark",
        "after:border-table-light": r === "light",
        "after:border-table-dark dark:after:border-table-light": r === "system",
        "after:border-table-light dark:after:border-table-dark": r === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ d("div", { className: j, children: /* @__PURE__ */ x(
      R,
      {
        ref: S,
        className: T,
        disabled: t,
        type: c,
        "aria-label": s || b,
        ...E,
        children: [
          g && /* @__PURE__ */ d("span", { className: "pr-2", children: g }),
          /* @__PURE__ */ d("div", { className: z, children: e }),
          u && /* @__PURE__ */ d("span", { className: "pl-2", children: u })
        ]
      }
    ) });
  }
);
ce.displayName = "ButtonSort";
/*!
  @versini/ui-spacing v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const se = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
}, ge = ({
  children: e,
  fill: t,
  viewBox: r,
  className: a,
  defaultViewBox: o,
  defaultClassName: n,
  spacing: c,
  title: l,
  semantic: h = !1,
  ...s
}) => {
  const b = se(c), v = i(
    b,
    a || n
  );
  return /* @__PURE__ */ x(L, { children: [
    /* @__PURE__ */ d(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: v,
        viewBox: r || o,
        fill: t || "currentColor",
        role: "img",
        "aria-hidden": !h,
        focusable: !1,
        ...s,
        children: e
      }
    ),
    l && h && /* @__PURE__ */ d("span", { className: "sr-only", children: l })
  ] });
};
/*!
  @versini/ui-svgicon v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const he = ({
  className: e,
  viewBox: t,
  spacing: r,
  title: a,
  monotone: o,
  ...n
}) => /* @__PURE__ */ d(
  ge,
  {
    defaultViewBox: "0 0 384 512",
    defaultClassName: "size-5",
    viewBox: t,
    className: e,
    spacing: r,
    title: a || "Close",
    ...n,
    children: /* @__PURE__ */ d("path", { d: "M342.6 150.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L192 210.7 86.6 105.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L146.7 256 41.4 361.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L192 301.3l105.4 105.3c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L237.3 256l105.3-105.4z" })
  }
);
/*!
  @versini/ui-icons v1.19.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "1.19.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const U = m.createContext(null);
function me({
  initialOpen: e = !1,
  open: t,
  onOpenChange: r
} = {}) {
  const [a, o] = m.useState(e), [n, c] = m.useState(), [l, h] = m.useState(), s = t ?? a, b = r ?? o, v = D({
    open: s,
    onOpenChange: b
  }), u = v.context, g = W(u, {
    enabled: t == null
  }), p = X(u, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), k = Y(u), f = q([g, p, k]);
  return m.useMemo(
    () => ({
      open: s,
      setOpen: b,
      ...f,
      ...v,
      labelId: n,
      descriptionId: l,
      setLabelId: c,
      setDescriptionId: h
    }),
    [s, b, f, v, n, l]
  );
}
const w = () => {
  const e = m.useContext(U);
  if (e == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return e;
};
function ue({
  children: e,
  ...t
}) {
  const r = me(t);
  return /* @__PURE__ */ d(U.Provider, { value: r, children: e });
}
const be = m.forwardRef(function(e, t) {
  const { context: r, ...a } = w(), o = H([a.refs.setFloating, t]);
  if (!r.open)
    return null;
  const { overlayBackground: n, ...c } = e, l = i("grid place-items-center", {
    [`${n}`]: n,
    "bg-black sm:bg-black/[.8]": !n
  });
  return /* @__PURE__ */ d(J, { children: /* @__PURE__ */ d(K, { className: l, lockScroll: !0, children: /* @__PURE__ */ d(Q, { context: r, children: /* @__PURE__ */ d(
    "div",
    {
      ref: o,
      "aria-labelledby": a.labelId,
      "aria-describedby": a.descriptionId,
      ...a.getFloatingProps(c),
      children: c.children
    }
  ) }) }) });
}), ve = m.forwardRef(function({ children: e, ...t }, r) {
  const { setLabelId: a } = w(), o = V();
  return m.useLayoutEffect(() => (a(o), () => a(void 0)), [o, a]), /* @__PURE__ */ d("h1", { ...t, ref: r, id: o, children: e });
}), fe = m.forwardRef(function({ children: e, ...t }, r) {
  const { setDescriptionId: a } = w(), o = V();
  return m.useLayoutEffect(() => (a(o), () => a(void 0)), [o, a]), /* @__PURE__ */ d("div", { ...t, ref: r, id: o, children: e });
}), pe = m.forwardRef(function(e, t) {
  const { setOpen: r } = w(), { trigger: a, className: o, ...n } = e, c = m.useCallback(() => r(!1), [r]);
  return /* @__PURE__ */ d("div", { className: o, children: m.cloneElement(a, {
    ref: t,
    onClick: c,
    ...n
  }) });
});
/*!
  @versini/ui-modal v1.1.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_MODAL__ || (window.__VERSINI_UI_MODAL__ = {
    version: "1.1.1",
    buildTime: "12/28/2024 05:53 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const y = "panel", _ = "messagebox", ke = ({
  className: e,
  kind: t,
  borderMode: r
}) => ({
  main: i("prose prose-lighter flex flex-col bg-surface-medium", {
    [`${P} max-h-full sm:max-h-[95%] min-h-full sm:min-h-[10rem] sm:rounded-lg sm:border-2`]: t === y,
    [`${P} w-full sm:w-[95%] md:max-w-2xl`]: t === y && !e,
    [`${C} rounded-lg border-2`]: t === _,
    [`${C} w-[95%] sm:w-[50%] md:max-w-2xl`]: t === _ && !e,
    [`${e}`]: !!e,
    "sm:border-border-dark": r === "dark" && t === y,
    "sm:border-border-accent": r === "light" && t === y,
    "border-border-dark": r === "dark" && t === _,
    "border-border-accent": r === "light" && t === _
  }),
  content: "flex flex-col py-2 sm:py-4 sm:px-4 px-2 overflow-y-auto",
  footer: "flex flex-grow flex-col sm:p-4 p-2",
  header: "sm:p-4 mb-0 p-2",
  close: "sm:p-4 p-2"
}), Ie = ({
  open: e,
  onOpenChange: t,
  title: r,
  children: a,
  footer: o,
  borderMode: n = "light",
  kind: c = y,
  className: l
}) => {
  const h = F(""), s = ke({ className: l, kind: c, borderMode: n });
  return G(() => (e && (h.current = document.title, document.title = `${r} | ${h.current}`), () => {
    e && (document.title = h.current);
  }), [r, e]), /* @__PURE__ */ d(L, { children: e && /* @__PURE__ */ d(ue, { open: e, onOpenChange: t, children: /* @__PURE__ */ x(be, { className: s.main, children: [
    /* @__PURE__ */ x("div", { className: "flex flex-row-reverse items-center justify-between", children: [
      /* @__PURE__ */ d(
        pe,
        {
          className: s.close,
          trigger: /* @__PURE__ */ d(
            A,
            {
              mode: "dark",
              focusMode: "light",
              noBorder: !0,
              label: "Close",
              children: /* @__PURE__ */ d(he, {})
            }
          )
        }
      ),
      /* @__PURE__ */ d(ve, { className: s.header, children: r })
    ] }),
    /* @__PURE__ */ d(fe, { className: s.content, children: a }),
    o && /* @__PURE__ */ d("div", { className: s.footer, children: o })
  ] }) }) });
};
export {
  C as MESSAGEBOX_CLASSNAME,
  P as PANEL_CLASSNAME,
  Ie as Panel
};
